#include "ofApp.h"

//--------------------------------------------------------------
void ofApp::setup(){	
	ofSetOrientation(OF_ORIENTATION_90_RIGHT);//Set iOS to Orientation Landscape Right
    ofSetRectMode(OF_RECTMODE_CENTER);
    ofxAccelerometer.setup();
	
	ofBackground(240,231,216);

	letter = 'A';

	testFont.load("FuturaStd-Book.otf", 500, true, true, true);

	testChar = testFont.getCharacterAsPoints(letter);
    
    fontSetup();

}

//--------------------------------------------------------------
void ofApp::fontSetup(){
    myRectangles.clear();
    vertices.clear();
    touched.clear();
    for(int i = 0; i < (int)testChar.getOutline()[0].size(); i++){
        ofPoint verticesPoints;
        verticesPoints.set(testChar.getOutline()[0].getVertices()[i].x+370, testChar.getOutline()[0].getVertices()[i].y+580);
        vertices.push_back(verticesPoints);
        
        ofRectangle myVertices;
        myVertices.set(verticesPoints, RECT_SIZE, RECT_SIZE);
        myRectangles.push_back(myVertices);

        bool myTouched;
        myTouched=false;
        touched.push_back(myTouched);

        
    }

}

//--------------------------------------------------------------
void ofApp::update(){
//    for(int i=0;i<myRectangles.size();i++){
//        vertices[i].update();
//    }
}

//--------------------------------------------------------------
void ofApp::draw(){
	ofSetColor(119, 116, 110);
    glLineWidth(4);

	ofDrawBitmapString("fps: "+ofToString(ofGetFrameRate()), 20, 20);

	string str = "";
	str += char(letter);

	//okay lets get the character back as shapes
	testChar.setFilled(true);



    ofFill();
    ofBeginShape();
        for(int i = 0; i < myRectangles.size(); i++){
            ofVertex(vertices[i].x, vertices[i].y);
        }
    ofEndShape( true );
    
    for(int i = 0; i < myRectangles.size(); i++){
        ofVertex(vertices[i].x, vertices[i].y);
        ofSetColor(111,199,174);
        (touched[i])? ofFill() : ofNoFill();
        ofDrawRectangle(myRectangles[i]);
    }
    


}

//--------------------------------------------------------------
void ofApp::exit(){
    
}

//--------------------------------------------------------------
void ofApp::touchDown(ofTouchEventArgs & touch){
    for(int i = 0; i < myRectangles.size(); i++){
        if(myRectangles[i].inside(touch)){
            touched[i]=true;
        }
    }

}

//--------------------------------------------------------------
void ofApp::touchMoved(ofTouchEventArgs & touch){



    
    
    
    for(int i = 0; i < myRectangles.size(); i++){
        if(myRectangles[i].inside(touch)){
            vertices[i]=touch;
            myRectangles[i].set(touch.x-35, touch.y-35, RECT_SIZE, RECT_SIZE);
            //cout << vertices[i] << endl;
        }else{
            ofFill();
            //vertices[i]+=ofxAccelerometer.getForce()/4;
            //myRectangles[i].set(vertices[i].x-35, vertices[i].y-35, RECT_SIZE, RECT_SIZE);
        }
    }
    


}

//--------------------------------------------------------------
void ofApp::touchUp(ofTouchEventArgs & touch){
    for(int i = 0; i < myRectangles.size(); i++){
        if(myRectangles[i].inside(touch)){
            touched[i]=false;
        }
    }

}

//--------------------------------------------------------------
void ofApp::touchDoubleTap(ofTouchEventArgs & touch){
    if( touch.id != 0 ){
        //letter = ofMap(touch.x, 10.0, ofGetWidth(), 33, 126, true);
        letter++;
        testChar = testFont.getCharacterAsPoints(letter);
        cout << char(letter) << endl;
        fontSetup();
    }

}

//--------------------------------------------------------------
void ofApp::touchCancelled(ofTouchEventArgs & touch){

}

//--------------------------------------------------------------
void ofApp::lostFocus(){
    
}

//--------------------------------------------------------------
void ofApp::gotFocus(){
    
}

//--------------------------------------------------------------
void ofApp::gotMemoryWarning(){
    
}

//--------------------------------------------------------------
void ofApp::deviceOrientationChanged(int newOrientation){
    
}
